#include <cstdlib>
#include <fstream>
#include <sstream>
#include <iostream>
#include "colors.hpp"

int main(int argc,char* argv[])
{
  if (argc<2)
    return EXIT_FAILURE;
  std::string line,goldPlayer,silverPlayer;
  ColorHistory colorHistory;
  for (int arg=1;arg<argc-1;++arg) {
    std::ifstream past(argv[arg]);
    while (std::getline(past,line)) {
      if (line.empty())
        continue;
      std::stringstream ss;
      ss<<line;
      if (!(ss>>goldPlayer))
        continue;
      if (!(ss>>silverPlayer))
        abort();
      colorHistory.addGame(goldPlayer,silverPlayer);
    }
  }
  std::ifstream future(argv[argc-1]);
  srand(time(0));
  while (std::getline(future,line)) {
    if (line.empty())
      continue;
    std::string player1,player2;
    std::stringstream ss;
    ss<<line;
    if (!(ss>>player1))
      continue;
    if (!(ss>>player2))
      abort();
    const int color=colorHistory.colorFirstPlayer(player1,player2);
    if (color>0 || (color==0 && (rand()%2)==0)) {
        goldPlayer=player1;
      silverPlayer=player2;
    }
    else {
      silverPlayer=player1;
        goldPlayer=player2;
    }
    std::cout<<goldPlayer<<'\t'<<silverPlayer<<'\n';
    colorHistory.addGame(goldPlayer,silverPlayer);
  }
}

